
#include "evtypes.h"
#include "Arduino.h"
#include <inttypes.h>
#define byte unsigned char 

pevnode eventlist = NULL ;
pevnode pevtop = NULL ;
bool pevinit = false ;
#define pevheapsize 20
teventnode pevheap[pevheapsize] ;

int pevcnt ;


void pevfree(void * p)  {
  ((teventnode *)p)->link = pevtop ;
  pevtop = (teventnode *) p ;
  pevcnt-- ;
}

#define forloop(x,y,z) for(x=(y);x<=(z);x++)

teventnode * pevmalloc(void) {
  int i ;
  if (!pevinit) {
    forloop(i,0,pevheapsize-2)
      pevheap[i].link = &pevheap[i+1] ;
    pevheap[pevheapsize-1].link = NULL ;
    pevtop = (teventnode *) &pevheap[0] ;
    pevinit = true ;  }
  teventnode * tmp = pevtop ;
  pevcnt++ ;
  if (pevtop != NULL)
    pevtop =  (teventnode *) pevtop->link ;
  return tmp ; 
}


#define kill_event killevent

void killevent(t_event ev) {
  pevnode prev = NULL ;
  pevnode hev = eventlist ;
  while (hev != NULL) {
    if (hev->eve == ev) {
      if (prev) {
        prev->link = hev->link ;
        pevfree(hev) ;
        hev = NULL ; }
      else {
        prev = eventlist ;
        eventlist = eventlist->link ;
        pevfree(prev) ;
        hev = NULL ; } }
     else {
       prev = hev ;
       hev = (pevnode) hev->link ; } }
}

#define nowtime() (unsigned long) (millis()+freeruntime)
unsigned long freeruntime  = 0xf800 ;

void later(int delay,t_event ev) {
  unsigned  long reftim ;
  pevnode nev ;
  pevnode hev ;
  pevnode prev ;
  killevent(ev) ;
  reftim = nowtime() ;
  nev = (pevnode)pevmalloc() ;
  if (nev != NULL) {
    if (pevcnt > pevheapsize-10)
      delay = 0 ;
    nev->link = NULL ;
    nev->eve = (t_event) ev ;
    nev->firetime = reftim+delay ;
    hev = (pevnode)eventlist ;
    prev = NULL ;
    if (hev == NULL) {
      eventlist = nev ; }
    while (hev != NULL) {
      if (hev->firetime > nev->firetime) {
        if (prev == NULL) {
          nev->link = eventlist ;
          eventlist = nev ; }
        else {
          nev->link = hev ;
          prev->link = nev ; }
        hev = NULL ; }
      else {
        prev = hev ;
        hev = (pevnode) hev->link ;
        if (hev == NULL)
    prev->link = nev ;} } }
}

int time_to_event(t_event ev) {
  int rslt = 0x7fffffff ;
  int n ;
  pevnode hev = eventlist ;
  while (hev != NULL) {
    if (hev->eve == ev) {
      n = hev->firetime-nowtime() ;
      if (n < rslt)
        rslt = n ; }
    hev = (pevnode) hev->link ; } 
  if (rslt == 0x7fffffff)
    rslt = -999 ;  
  return rslt ; }

#define timelimit 0x7e00000 

t_event ev_timcor = NULL ;
t_event current_event ;

bool peek_event(void) {
  unsigned long reftime ;
  pevnode hev ;
  reftime = nowtime() ;
  if (reftime > timelimit) {
    hev = eventlist ;
    while (hev != NULL) {
      hev->firetime -= timelimit ;
      hev = (pevnode) hev->link ; }
    freeruntime -= timelimit ;
    if (ev_timcor)
      (*ev_timcor)() ;
    return true ;  
    //return ev_timcor ; 
    }
  current_event = (t_event) NULL ;
  if (eventlist != NULL) {
    if (eventlist->firetime <= reftime) {
      current_event = eventlist->eve ;
      hev = eventlist ;
      eventlist = (pevnode) eventlist->link ;
      pevfree(hev) ;} }
   if (current_event)
     (*current_event)() ;   
   return (current_event != NULL) ; }

//pins
int led = 13 ;

int lim(int x,int mn,int mx) {
  if (x > mx)
    x = mx ;
  if (x < mn)
    x = mn ;
  return x ; }  
  
int darkledtime = 800 ;
int brightledtime = 200 ;
 
void restoreblink(void) {
  darkledtime = 800 ;
  brightledtime = 200 ; }



int teller = 0 ;
void led_on(void) { 
  digitalWrite(led,HIGH) ; 
  later(brightledtime,led_off) ;
}

  
void led_off(void) { 
  digitalWrite(led,LOW) ; 
  later(darkledtime,led_on) ;
}

void setblink(int ontim,int offtim) {
  darkledtime = offtim ;
  brightledtime = ontim ; 
  if (time_to_event(led_off) > ontim)
    later(offtim,led_off) ;
  else
    if (time_to_event(led_on) > offtim)
      later(offtim,led_on) ;
  later(5000,restoreblink) ; } 



//servo constants -- trim as needed
#define servo1control OCR1A       // servo1 is connected to Arduino pin9
#define servo2control OCR1B     // servo2 is connected to Arduino pin10






byte dlttable[562] = {

  0,   0,   0,   0,   0,  57,   3,  62, 191, 191, 191, 182, 201, 201, 180, 219,
  219,   3,  46, 195, 184, 204, 187, 195, 213, 185, 213, 226,   0,   0,   0,   0,
  0, 112,   5, 118, 153, 153, 153, 142, 162, 162, 135, 176, 176, 133, 197, 197,
  137, 223, 223,   5, 110, 156, 144, 166, 145, 154, 174, 138, 169, 188, 136, 192,
  207, 140, 225, 230,   4,  91, 164, 139, 184, 153, 150, 191, 147, 167, 203, 146,
  190, 219,   3,  54, 181, 140, 206, 170, 152, 212, 166, 168, 221,   0,   0,   0,
  0,   0, 144,   6, 150, 124, 124, 124, 111, 133, 133, 102, 148, 148,  98, 167,
  167,  99, 194, 194, 105, 223, 223,   6, 144, 126, 113, 138, 113, 123, 147, 105,
  138, 161, 101, 159, 179, 102, 188, 204, 107, 225, 229,   6, 130, 134, 107, 157,
  121, 117, 165, 113, 133, 177, 109, 156, 195, 111, 190, 218, 119,  76,  77,   5,
  105, 147, 105, 179, 135, 116, 186, 127, 134, 197, 124, 160, 213, 126, 198, 231,
  3,  61, 170, 109, 204, 157, 121, 210, 151, 139, 219,   0,   0,   0,   0,   0,
  165,   7, 171,  96,  96,  96,  81, 107, 107,  71, 123, 123,  67, 143, 143,  67,
  170, 170,  72, 204, 204,  81, 247, 247,   7, 165,  98,  83, 113,  84,  95, 123,
  74, 111, 138,  69, 133, 157,  69, 161, 182,  75, 200, 213,  85,  90,  91,   6,
  153, 106,  76, 134,  91,  87, 143,  82, 104, 157,  77, 127, 175,  77, 158, 197,
  82, 195, 220,   6, 133, 120,  74, 158, 105,  85, 166,  95, 102, 178,  90, 127,
  194,  91, 162, 215,  97,  84,  91,   5, 101, 140,  76, 184, 126,  88, 191, 116,
  107, 202, 112, 134, 217, 114, 176, 234,   3,  34, 173,  85, 214, 159,  97, 219,
  151, 117, 228,   0,   0,   0,   0,   0, 178,   7, 185,  66,  66,  66,  49,  79,
  79,  39,  98,  98,  34, 121, 121,  35, 150, 150,  41, 185, 185,  50, 222, 222,
  7, 179,  69,  52,  86,  52,  65,  99,  41,  84, 116,  37, 108, 138,  38, 139,
  165,  44, 178, 196,  51, 218, 226,   7, 168,  78,  43, 111,  61,  56, 123,  50,
  75, 138,  45, 100, 158,  46, 133, 182,  51, 177, 211,  60,  99, 106,   6, 150,
  93,  41, 139,  75,  53, 149,  64,  72, 163,  59,  98, 180,  59, 134, 202,  63,
  174, 222,   5, 122, 115,  45, 169,  97,  56, 177,  85,  75, 188,  79, 102, 204,
  79, 136, 220,   4,  74, 146,  53, 200, 129,  65, 206, 117,  85, 215, 112, 109,
  226,   0,   0,   0,   0,   0, 186,   7, 192,  30,  30,  30,  10,  46,  46,   0,
  70,  70,   0,  99,  99,   2, 133, 133,  11, 172, 172,  23, 218, 218,   7, 187,
  34,  13,  55,  14,  28,  72,   4,  52,  94,   1,  82, 121,   5, 119, 151,  13,
  162, 185,  23, 209, 220,   7, 176,  45,   5,  87,  25,  19, 102,  14,  41, 121,
  10,  72, 145,  13, 110, 171,  21, 158, 202,  30, 211, 228,   6, 159,  63,   5,
  122,  42,  18, 134,  30,  39, 150,  26,  68, 170,  27, 108, 193,  34, 162, 219,
  6, 133,  88,  11, 157,  67,  23, 166,  53,  43, 179,  47,  72, 196,  48, 114,
  216,  54, 192, 237,   4,  90, 123,  21, 191, 101,  33, 197,  86,  53, 208,  80,
  78, 220};
int zbase[7] = {  5, 33, 98,192,312,438,561};



byte * intable(int ix,int iy,int iz) {
  iz = lim(iz,0,5) ;
  int idx = zbase[iz]+1 ;
  while (iy > 0) {
    idx += 3*dlttable[idx]+2,0 ;
    if (idx >= zbase[iz+1]-5)
      iy = 1 ;
    iy-- ; }
  ix = lim(ix,0,dlttable[idx]-1) ;
  idx++ ;
  idx++ ;
  while (ix > 0) {
    idx += 3 ;
    ix -- ; }
  return &dlttable[idx] ; }

#define intloop(x,y,z) for (int x=y;x<=(z);x++)
typedef long int int32 ;
typedef int int16 ;


void avgtable(long xyz[3],int abc[3]) {
  int tidx[3] ;
  int tfrac[3][2] ;
  long tmp ;
  xyz[2] += 300 ;
  int txyz[3] ;
  intloop(i,0,2)
    txyz[i] = xyz[i] ;
  intloop(i,0,2) {
    tidx[i] = xyz[i]/32 ;
    tfrac[i][1] = xyz[i] - 32*tidx[i] ;
    tfrac[i][0] = 32-tfrac[i][1] ; }
  byte * bptr ;
  int32 asum[3] = {0,0,0} ;
  intloop(ix,0,1) {
    int32 weight0 = tfrac[0][ix] ;
    intloop(iy,0,1) {
      int32 weight1 = weight0*tfrac[1][iy] ;
      intloop(iz,0,1) {
        bptr = intable(tidx[0]+ix,tidx[1]+iy,tidx[2]+iz) ;
        int32 weight = weight1*tfrac[2][iz] ;
        intloop(i,0,2)
          asum[i] += weight*bptr[i] ; }} }
  intloop(i,0,2) {
    tmp = asum[i]*3/(32L*32L*32L) ;
    abc[i] = tmp ;}

}


#define swapmc(typ,a,b) do {typ tmp = a;a=b;b=tmp;} while(0) ;

int isin120 = 3547 ;
int icos120 = -2048 ;

void xyz2angles(int xyz[3],int abc[3]) {
  int32 rxyz[3][3] ;
  intloop(i,0,2)
    rxyz[0][i] = xyz[i] ;
  intloop(j,1,2) {
    rxyz[j][2] = rxyz[j-1][2] ;
    rxyz[j][0] = (icos120*rxyz[j-1][0]-isin120*rxyz[j-1][1]) >> 12 ;
    rxyz[j][1] = (isin120*rxyz[j-1][0]+icos120*rxyz[j-1][1]) >> 12 ; }
  int k = 0 ;
  intloop(i,1,2)
    if (rxyz[i][0] > rxyz[k][0])
      k = i ;
  bool flip = rxyz[k][1] < 0 ;
  if (flip)
    rxyz[k][1] = - rxyz[k][1] ;
  int16 iabc[3] ;
  avgtable(rxyz[k],iabc) ;
  if (flip)
    swapmc(int,iabc[1],iabc[2]) ;
  intloop(i,0,2) {
    abc[i] = iabc[k++] ;
    if (k==3)
      k = 0 ; }
}
  





int prev_puls = 0 ; 


void set_servo(int puls) { // 600 closed 2200 open
  if (puls == 0)
    TCCR1A = 0b00100010 ;
  else {
    if (prev_puls == 0)
      TCCR1A = 0b10100010 ;
    servo1control = 2*puls ; }
  prev_puls = puls ;
}

int mixelque[32] ; 
int mxqueput = 0 ;
int mxqueget = 0 ;
#define mxquemask 31
bool mixelbusy = false ;

void mixeltmo(void) {
  setblink(100,100) ;
  later(1000,mixqueread) ;
}

bool expectresponse = false ;

int incbyte(int & x) {
  int rslt = x ;
  x = (x+1) & 31 ;
  return rslt ;
  }

unsigned char mixelfifo[32] ; 
int mixelput = 0 ;
int mixelget = 0 ;
#define mxfifmask 31 
int mixelstat ;
bool mixeldebug = false ;
void sendmixel(unsigned char * buf,int len) {
  int sum = 0 ;
  intloop(i,2,len-2)
    sum += buf[i] ;
  sum &= 255 ;
  buf[len-1] = ~sum ;
  mixelget = mixelput ;
  intloop(i,0,len-1)
    mixelfifo[incbyte(mixelput)] = buf[i] ;
  if (expectresponse) {
    mixelfifo[incbyte(mixelput)] = 0xff ;
    mixelfifo[incbyte(mixelput)] = 0xff ;}
  intloop(i,0,len-1)
    Serial.write(buf[i]) ;  
  mixelstat = 0 ;
  later(100,mixeltmo) ;
  }

int mixel_id = 1 ;

void setmixelregister(int id,int regnr,int val, int nrbyte) {
  unsigned char buf[20] = {0xff,0xff,1,6,3,30,0,1,55} ;
  int len = nrbyte+7 ;
  buf[2] = id ;
  buf[3] = 3+nrbyte ;
  buf[5] = regnr ;
  int j = 6 ;
  while (nrbyte > 0) {
    buf[j++] = val & 255 ;
    val = val >> 8 ;
    nrbyte-- ; }
  expectresponse = true;
  sendmixel(buf,len) ; }



int inmixelque(void) {
  return (32+mxqueput-mxqueget) & mxquemask ; }





  
void mixqueread(void) {
  mixelbusy = (mxqueput != mxqueget) ;
  if (mixelbusy){
    mixel_id = mixelque[incbyte(mxqueget)] ;
    int reg  = mixelque[incbyte(mxqueget)] ;
    int val  = mixelque[incbyte(mxqueget)] ;
    //print3int(mixel_id,reg,val) ;
    setmixelregister(mixel_id,reg & 255,val,(reg>255)?1:2) ;
    }
}


void gotoabc(int legnr ,int * abc) {
  if (inmixelque()<32-9) {
    intloop(i,0,2) {
      mixelque[incbyte(mxqueput)] = (i==0)?i+4:i+1 ;
      mixelque[incbyte(mxqueput)] = 30 ;
      mixelque[incbyte(mxqueput)] = abc[i] ; }
    if (!mixelbusy)
      mixqueread() ; }
}

void mixelspeeds(int * speeds) {
  if (inmixelque()<32-9) {
    intloop(i,0,2) {
      mixelque[incbyte(mxqueput)] = (i==0)?i+4:i+1 ;
      mixelque[incbyte(mxqueput)] = 32 ;
      mixelque[incbyte(mxqueput)] = speeds[i] ; }
    if (!mixelbusy)
      mixqueread() ; }
}
int rcv_id ;
int rcv_val ;

void mixelbyte(unsigned char mxb) {
  unsigned char buf[2] ;
  static int rcvlen ;
  static int csum ;
  static bool hasval ;
  static int fshift ;
  int btr = 1 ;
  buf[0] = mxb ;
  intloop(i,0,btr-1) {
    if ((mixelput != mixelget) && (mixelfifo[mixelget] == buf[i])) {
      csum = 255 ;
      rcvlen = 999 ;
      incbyte(mixelget) ;
      if (!expectresponse && (mixelget == mixelput)) {
        kill_event(mixeltmo) ;
        mixqueread() ; } }
    else  {
      csum -= buf[i] ;
      rcvlen-- ;
      switch(mixelstat) {
        case 0 :
          rcv_id = buf[i] ;
          if (rcv_id != mixel_id) { // id error
            setblink(50,200) ;  }
          break ;
        case 1 :
          rcvlen = buf[i] ;
          rcv_val = 0 ;
          fshift = 0 ;
          hasval = false  ;
          break ;
        case 2 :
          if (buf[i] != 0) {
            setblink(300,50) ;  } // error code in response
          break ;
        case 3 : {
          if (rcvlen == 0) {
            if ((csum & 255)  != 0) {
              setblink(1000,1000) ; } // checksum error
            kill_event(mixeltmo) ;  
            mixqueread() ;           }
          else {
            hasval = true ;
            rcv_val += buf[i] << fshift ;
            fshift += 8 ;}
          mixelstat-- ; } }
      mixelstat++ ; }
        }
}

void singlespeed(void) {
  int i = 0 ;
  mixelque[incbyte(mxqueput)] = (i==0)?i+4:i+1 ;
  mixelque[incbyte(mxqueput)] = 32 ;
  mixelque[incbyte(mxqueput)] = 0x100 ; 
  if (!mixelbusy)
    mixqueread() ;
  later(2000,singlespeed) ; }


void serialEvent() {
  while (Serial.available()) {
    char rxChar = (char)Serial.read(); 
    mixelbyte((unsigned char)rxChar) ;
    } 
}


void servosetup(){
  pinMode(9,OUTPUT);
  pinMode(10,OUTPUT);
  TCCR1B = 0b00011010;          // Fast PWM, top in ICR1, /8 prescale (.5 uSec)
  TCCR1A = 0b10100010;          //clear on compare match, fast PWM
                               // to use pin 9 as normal input or output, use  TCCR1A =  0b00100010
                               // to use pin 10 as normal input or output, use  TCCR1A = 0b10000010
  ICR1 =  39999;                // 40,000 clocks @ .5 uS = 20mS
  set_servo(0) ;
  servo2control = 30000 ;
}

int notnul(int x) {
  if (x == 0)
    return 1 ;
  else
    return x ; }


int ivsqrt(long input) // integer square root
{
  int16 nv ;
  int32  v = input>>1 ;
  char c = 0 ;
  if (!v)
    return input;
  do {
    nv = (v + input/v)>>1;
    v = v-nv ;
    if ((v  <= 1) && (v >= -1))
      return nv;
    v = nv;
    } while (c++ < 25);
  return nv;
}




int mmpersec = 200 ;
int maxrotate = 0x300 ;
int timetomove = 100 ;
#define sqr(x) ((x)*(x))
void set_speeds(int xyz[3],int oldxyz[3],int abc[3],int oldabc[3]) {
  long sqsum = 0 ;
  intloop(i,0,2)
    sqsum += sqr((long)(xyz[i]-oldxyz[i])) ;
  long rtim = (long)ivsqrt(sqsum)*1000L/mmpersec ;
  int tim = notnul(rtim) ;
  timetomove = tim ;
  int speeds[3] ;
  if (oldabc[0] < 0) {
    timetomove = 100 ;
    intloop(i,0,2)
      speeds[i] = maxrotate/2 ; }
  else {
    intloop(i,0,2) {
      speeds[i] = lim(60L*(long)abs(oldabc[i]-abc[i])*1000L/(long)tim/114L,5,maxrotate) ; } }
  mixelspeeds(speeds) ;
}

int prevabc[3] = {-1,-1,-1} ;
int prevxyz[3] = {0,0,-174} ;
void grippertoxyz(int * xyz) {
  int abc[3] ;
  xyz2angles(xyz,abc) ;
  intloop(i,0,2)
    abc[i] = 486+256-abc[i]/2  ;
  set_speeds(xyz,prevxyz,abc,prevabc) ;
  gotoabc(0,abc) ;
  intloop(i,0,2) {
    prevabc[i] = abc[i] ;
    prevxyz[i] = xyz[i] ; }
   }

int griploopidx = 0 ;
#define SRV 2000
#define DLY 3000
#define MVS 4000
#define NWZ 6000
#define RMV 70
#define RMY 60
int gripseq[100] = {SRV+220,DLY+1
  ,RMV,0,-174
  ,NWZ-240,SRV+60,DLY+100
  ,NWZ-174
  ,-RMV/2,RMY,-174
  ,NWZ-240,SRV+220
  ,NWZ-174

  ,-RMV/2,-RMY,-174
  ,NWZ-240,SRV+60,DLY+100
  ,NWZ-174
  ,RMV,0,-174
  ,NWZ-240,SRV+220
  ,NWZ-174

  ,-RMV/2,RMY,-174
  ,NWZ-240,SRV+60,DLY+100
  ,NWZ-174
  ,-RMV/2,-RMY,-174
  ,NWZ-240,SRV+220
  ,NWZ-174


  ,9999} ;
  
  
void griploop(void)
{
  int xyz[3] ;
  memcpy(xyz,prevxyz,3*sizeof(int)) ;
  int ncode = gripseq[griploopidx] ;
  if (ncode < 1000) {
    intloop(i,0,2)
      xyz[i] = gripseq[griploopidx++] ;
    grippertoxyz(xyz) ; }
  else {
    griploopidx++ ;
    timetomove = 1 ;
    if (ncode >= SRV && ncode < SRV+1000)
      set_servo((ncode-SRV)*10) ;
    if (ncode >= DLY && ncode < DLY+1000)
      timetomove = ncode-DLY ;
    if (ncode >= MVS && ncode < MVS+1000)
      timetomove = notnul(1000*(ncode-MVS)/mmpersec) ;
    if (ncode > NWZ-1000 && ncode < NWZ+1000) {
      xyz[2] = ncode-NWZ ;
      grippertoxyz(xyz) ; }
      }
  if (gripseq[griploopidx] > 9998)
    griploopidx = 0 ;
  later(timetomove,griploop) ;  
}
//---------------------------------------------------------------------------


void setup(void) {
  pinMode(led, OUTPUT);
  Serial.begin(19230) ; // was 57600
  servosetup() ;
  later(100,led_off) ;
  later(1000,griploop) ;
  }

void loop(void) {
  peek_event()  ;
}


